﻿601,100
602,"}APQ.UX.Security.ClientGroups.Import.FromInstances"
562,"NULL"
586,"D:\TM1Models\CAMAuthentication\Export\CAMUsers.csv"
585,"D:\TM1Models\CAMAuthentication\Export\CAMUsers.csv"
564,
565,"qoDVS;gt41LEmRxmNaP:wY=7M>3PG9PjTitp1c9TzHR>im:49HeivwfMVRAbZ1^w]_uY?h<zVmQKfjE_mV6DH>6iHz8Xn08SLUHEr<KIMpT;u>mZ>8U<ZIWj[swN`qpGH7Qs=33\DqrFUvXnGZDakTmAQ\16?o_x]ysFDtKdgt1XScxQwN3dG71Ke;kTdqfNXb8euFU@"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,","
568,"'"
570,
571,
569,1
592,0
599,1000
560,1
pClear
561,1
2
590,1
pClear,"0"
637,1
pClear,"Optional: Clear current group memberships before import?"
577,0
578,0
579,0
580,0
581,0
582,0
603,0
572,322
##############################################################################################################################
#Region - Header
# APLIQO UX FRAMEWORK
# Copyright 2016-2019, Apliqo AG. All rights reserved.
# This software and related documentation are provided under a license agreement containing restrictions on use and disclosure
# and are protected by intellectual property laws. Except as expressly permitted in your license agreement or allowed by law,
# you may not use, copy, reproduce, translate, broadcast, modify, license, transmit, distribute, exhibit, perform, publish,
# or display any part, in any form, or by any means.
##############################################################################################################################

#****Begin: Generated Statements***
#****End: Generated Statements****

##############################################################################################################################
#Region - Change History
# MODIFICATION DATE     CHANGED BY  COMMENT
# 2018-11-21 		    SW   	    Creation of Process
# 2018-02-13            SW          Added sync of Leaves hierarchy as precursor
# 2019-02-14 		    SW 	        Ensure users always added to APQ User group
# 2019-04-05 		    SW 	        Fix settings json. Add DocString
# 2020-04-01 		    SW 	        Allow for manual maintenance of }Clients & }Groups vs. sync from source instance (#1116)
# 2020-05-13 		    SW 	        Fix MDX for CAM groups containing quotes in element name (#1242)
# 2020-08-27 		    SW 	        Update for mechanism to detect white space in encrypted password (#1380)
# 2022-02-18 		    SW 	        Sync attribute values from }Clients to }APQ UX Client as well as adding members (#1662). Ensure Admin always in ADMIN group (#1663, BB#243)
#EndRegion - Change History
##############################################################################################################################
#Region @DOC
# Description:
# Import users, groups& memberships from metadata read from other instances in the instances.json file. Allows security to be maintained
# in the source instances and re-used in the content store without re-defining clients, groups or group memberships. 
#
# Data Source: 
# * Cube: }APQ UX Instance Client, }APQ UX Instance Group, }APQ UX Instance ClientGroups
#
# Target objects:
# * Dimension: }Clients, }Groups
# * Cube: }APQ UX Security Manage Client Groups, }ClientGroups
#
# Use Case:
# Synchronize users, groups and group memberships from source instances to the content store security model.
#
# Note:
# * All admin users require READ access to this process. This is managed in the **APQ Admin** group.
#EndRegion @DOC
##############################################################################################################################
#Region - Logging
pDoProcessLogging   = '1';
sThisProcName       = GetProcessName();
### Params
sProcLogParams      = Expand('pClear:%pClear%');
### Params
IF( pDoProcessLogging @= '1' ); IF( sProcLogParams @<> '' ); LogOutput( 'INFO', sThisProcName | ' run with parameters ' | sProcLogParams ); EndIF;
  sProcLogCube = '}APQ UX Process Execution Log'; nProcessStartTime = Now(); nProcessFinishTime = 0; nMetaDataRecordCount = 0; nDataRecordCount = 0;
  NumericGlobalVariable( 'PrologMinorErrorCount' );  PrologMinorErrorCount = 0; NumericGlobalVariable( 'MetadataMinorErrorCount' );  MetadataMinorErrorCount = 0; NumericGlobalVariable( 'DataMinorErrorCount' );  DataMinorErrorCount = 0; NumericGlobalVariable( 'ProcessReturnCode' );  ProcessReturnCode = 0;
  sProcessErrorLogFile = ''; sProcessRunBy = TM1User(); IF( DimIx( '}Clients', sProcessRunBy ) > 0 ); sProcessRunBy = IF( AttrS( '}Clients', sProcessRunBy, '}TM1_DefaultDisplayValue' ) @= '', sProcessRunBy, AttrS( '}Clients', sProcessRunBy, '}TM1_DefaultDisplayValue' ) ); EndIF;
  sLogYear = TimSt( nProcessStartTime, '\Y' ); sLogDay = TimSt( nProcessStartTime, '\m-\d' ); sLogMinute = TimSt( nProcessStartTime, '\h:\i' ); sLogSecond = TimSt( nProcessStartTime, '\s' ); IF( DimIx( '}APQ UX Processes', sThisProcName ) = 0 );DimensionElementInsertDirect('}APQ UX Processes','',sThisProcName,'N');EndIF;
  nProcessExecutionIndex = CellGetN( sProcLogCube, 'Total APQ Time Year', 'Total Year', 'Total Day', 'Total Minute', sThisProcName, 'nProcessStartedFlag' ) + 1; nProcessExecutionIntraDayIndex = CellGetN( sProcLogCube, sLogYear, sLogDay, 'Total Day', 'Total Minute', sThisProcName, 'nProcessStartedFlag' ) + 1;
  sYear01 = sLogYear; sYear02 = sLogYear; sDay01 = sLogDay; sDay02 = 'D000'; sMinute01 = sLogMinute; sMinute02 = 'Total Day Entry'; sSecond01 = sLogSecond; sSecond02= 'Last Entry'; nCountTime = 1; nTotalLogTime = 2; 
  While ( nCountTime <= nTotalLogTime ); sLoggingYear = Expand( '%sYear' | NumberToStringEx( nCountTime, '00', '', '' ) | '%' ); sLoggingDay = Expand( '%sDay' | NumberToStringEx( nCountTime, '00', '', '' ) | '%' ); sLoggingMinute = Expand( '%sMinute' | NumberToStringEx( nCountTime, '00', '', '' ) | '%' ); sLoggingSecond = Expand( '%sSecond' | NumberToStringEx( nCountTime, '00', '', '' ) | '%' );
  CellPutN( nProcessStartTime, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nProcessStartTime' ); CellPutN( 1, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nProcessStartedFlag' );
  CellPutN( nProcessExecutionIndex, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nProcessExecutionIndex' ); CellPutN( nProcessExecutionIntraDayIndex, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nProcessExecutionIntraDayIndex' );
  CellPutS( sProcessRunBy, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'sRunBy' ); CellPutS( sProcLogParams, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'sParams' ); nCountTime = nCountTime + 1; End;
EndIF; 
#EndRegion - Logging
##############################################################################################################################
#EndRegion - Header
##############################################################################################################################
### Prolog script 
##############################################################################################################################

##############################################################################################################################
#Region - Constants Declaration
cDimSrc1        = '}APQ UX Client';
cDimSrc2        = '}APQ UX Group';
cCubSrc1        = '}APQ UX Instance Client';
cCubSrc2        = '}APQ UX Instance Group';
cCubSrc3        = '}APQ UX Instance ClientGroups';
cDimTgt1        = '}Clients';
cDimTgt2        = '}Groups';
cCubTgt1        = '}ClientGroups';
cCubTgt2        = '}APQ UX Security Manage Client Groups';
cCubTgt3        = '}DimensionSecurity';
cCubTgt4        = '}ClientProperties';
cDimInstance    = '}APQ UX Instance';
cCubParam       = '}APQ Settings';
cAlias          = '}TM1_DefaultDisplayValue';
sTimeStamp      = TimSt( Now, '\Y\m\d\h\i\s' );
sRandomInt      = NumberToString( INT( RAND( ) * 1000 ));
cUsrDummy       = 'ALL USERS PLACEHOLDER';
cGrpDummy       = 'ALL GROUPS PLACEHOLDER';
sDelimList      = CellGetS( cCubParam, 'pDelim', 'String' );
cGrpUsr         = CellGetS( cCubParam, 'Security Group: End User', 'String' );
cGrpPUsr        = CellGetS( cCubParam, 'Security Group: Power User', 'String' );
cGrpAdmn        = CellGetS( cCubParam, 'Security Group: Admin User', 'String' );
cDefUsr         = CellGetS( cCubParam, 'Default User', 'String' );
cViewSrcPrefix  = CellGetS( cCubParam, 'Std Datasource View Prefix', 'String' );
cViewSrc        = cViewSrcPrefix | sThisProcName |'_'| sTimeStamp |'_'| sRandomInt;
cSubSrc         = cViewSrc;
nErr            = 0;
sErr            = '';

# ContentStore password update mode (#1380)
sMeasPwdSrc = 'EncryptedPassword';
sMeasPwdTgt = 'PASSWORD';

# Set Data Source
DataSourceType              = 'NULL';
DataSourceNameForServer     = '';
DataSourceDimensionSubset   = '';    
DataSourceCubeView          = '';    
DataSourceQuery             = '';    
#EndRegion - Constants Declaration
##############################################################################################################################

##############################################################################################################################
#Region - Update UX objects from current security
# if content store security maintained manually and not via uxtoolkit metadata sync then update UX replica dimensions and group maintenance cube.
sDimSrc = cDimTgt1;
sDimTgt = cDimSrc1;
If( HierarchyExists( sDimTgt, 'contentStore' ) = 0 );
    HierarchyCreate( sDimTgt, 'contentStore' );
EndIf;
nMax    = DimSiz( sDimSrc );
nEle    = 1;
While( nEle <= nMax );
    sEle = DimNm( sDimSrc, nEle );
    If( DimIx( sDimTgt, sEle ) = 0 );
        DimensionElementInsertDirect( sDimTgt, '', sEle, 'N' );
        DimensionElementComponentAddDirect( sDimTgt, 'Total Clients', sEle, 1 );
    EndIf;
    If( ElementIndex( sDimTgt, 'contentStore', sEle ) = 0 );
        HierarchyElementInsertDirect( sDimTgt, 'contentStore', '', sEle, 'N' );
    EndIf;
    sAlias = AttrS( sDimSrc, sEle, cAlias );
    sAlias = If( sAlias @= '', sEle, sAlias );
    If( AttrS( sDimTgt, sEle, cAlias ) @= '' );
        AttrPutS( sAlias, sDimTgt, sEle, cAlias );
    EndIf;
    If( AttrS( sDimTgt, sEle, 'Caption' ) @= '' );
        AttrPutS( sAlias, sDimTgt, sEle, 'Caption' );
    EndIf;
    nEle = nEle+ 1;
End;

sDimSrc = cDimTgt2;
sDimTgt = cDimSrc2;
If( HierarchyExists( sDimTgt, 'contentStore' ) = 0 );
    HierarchyCreate( sDimTgt, 'contentStore' );
EndIf;
nMax    = DimSiz( sDimSrc );
nEle    = 1;
While( nEle <= nMax );
    sEle = DimNm( sDimSrc, nEle );
    If( DimIx( sDimTgt, sEle ) = 0 );
        DimensionElementInsertDirect( sDimTgt, '', sEle, 'N' );
        DimensionElementComponentAddDirect( sDimTgt, 'Total Groups', sEle, 1 );
    EndIf;
    If( ElementIndex( sDimTgt, 'contentStore', sEle ) = 0 );
        HierarchyElementInsertDirect( sDimTgt, 'contentStore', '', sEle, 'N' );
    EndIf;
    sAlias = AttrS( sDimSrc, sEle, cAlias );
    sAlias = If( sAlias @= '', sEle, sAlias );
    If( AttrS( sDimTgt, sEle, cAlias ) @= '' );
        AttrPutS( sAlias, sDimTgt, sEle, cAlias );
    EndIf;
    If( AttrS( sDimTgt, sEle, 'Caption' ) @= '' );
        AttrPutS( sAlias, sDimTgt, sEle, 'Caption' );
    EndIf;
    nEle = nEle+ 1;
    # loop all members of group
    sMDX = Expand('{Filter({[}Clients].Members},[}ClientGroups].([}Clients].CurrentMember,[%sDimSrc%].[%sEle%])=''%sEle%'')}');
    If( SubsetExists( cDimTgt1, cSubSrc ) = 0 );
        SubsetCreatebyMDX( cSubSrc, sMDX, cDimTgt1, 1 );
    Else;
        SubsetMDXSet( cDimTgt1, cSubSrc, sMDX );
    EndIf;
    SubsetElementInsert( cDimTgt1, cSubSrc, 'Admin', 1 );
    SubsetElementDelete( cDimTgt1, cSubSrc, 1 );
    nUsr = 1;
    While( nUsr <= SubsetGetSize( cDimTgt1, cSubSrc ) );
        sUsr = SubsetGetElementName( cDimTgt1, cSubSrc, nUsr );
        If( CellIsUpdateable( cCubTgt2, sUsr, sEle, 'Assignment' ) = 1 );
            CellPutN( 1, cCubTgt2, sUsr, sEle, 'Assignment' );
        EndIf;
        nUsr = nUsr + 1;
    End;
End;
#EndRegion - Update UX objects from current security
##############################################################################################################################

##############################################################################################################################
#Region - Check metadata

### Make sure Leaves hierarchies are in sync
sProc           = '}bedrock.hier.leaves.sync';
sDimFilter      = Expand('}APQ UX Client%sDelimList%}APQ UX Cube%sDelimList%}APQ UX Dimension%sDelimList%}APQ UX Group');
nRet            = ExecuteProcess( sProc,
    'pLogOutput', StringToNumber( pDoProcessLogging ),
    'pDim', sDimFilter,
    'pHier', '',
    'pDelim', sDelimList
);

### Make sure display alias exists
If( DimIx( '}ElementAttributes_' | cDimTgt1, cAlias ) = 0 );
    AttrInsert( cDimTgt1, '', cAlias, 'A' );
EndIf;
If( DimIx( '}ElementAttributes_' | cDimTgt2, cAlias ) = 0 );
    AttrInsert( cDimTgt2, '', cAlias, 'A' );
EndIf;

### Check if default user & security groups are entered in settings cube
If( cDefUsr     @= '' );
    cDefUsr     = 'Default User';
    CellPutS( cDefUsr, cCubParam, 'Default User', 'String' );
EndIf;
If( cGrpUsr     @= '' );
    cGrpUsr     = 'APQ User';
    CellPutS( cGrpUsr, cCubParam, 'Security Group: End User', 'String' );
EndIf;
If( cGrpPUsr     @= '' );
    cGrpPUsr     = 'APQ PUser';
    CellPutS( cGrpPUsr, cCubParam, 'Security Group: Power User', 'String' );
EndIf;
If( cGrpAdmn     @= '' );
    cGrpAdmn     = 'APQ Admin';
    CellPutS( cGrpAdmn, cCubParam, 'Security Group: Admin User', 'String' );
EndIf;

### Make sure default APQ groups exist
If( DimIx( cDimTgt2, cGrpAdmn ) = 0 );
    AddGroup( cGrpAdmn );
EndIf;
If( DimIx( cDimTgt2, cGrpPUsr ) = 0 );
    AddGroup( cGrpPUsr );
EndIf;
If( DimIx( cDimTgt2, cGrpUsr ) = 0 );
    AddGroup( cGrpUsr );
EndIf;

#EndRegion - Check metadata
##############################################################################################################################

##############################################################################################################################
#Region - Update Security

### Clear existing security group memberships
If( pClear @= '1' );
    CubeClearData( cCubTgt1 );
    CubeClearData( cCubTgt2 );
EndIf;

### Loop source cubes to make data change (to force dependency model to recalculate rule calc numeric values after process runs)
nInst = 1;
While( nInst <= ElCompN( cDimInstance, 'Total Instances' ) );
    sInst = ElComp( cDimInstance, 'Total Instances', nInst );
    If( CellIsUpdateable( cCubSrc1, sInst, 'Admin', 'IsUsed' ) = 1 );
        CellPutN( 0, cCubSrc1, sInst, 'Admin', 'IsUsed' );
    EndIf;
    If( CellIsUpdateable( cCubSrc2, sInst, 'ADMIN', 'IsUsed' ) = 1 );
        CellPutN( 0, cCubSrc2, sInst, 'ADMIN', 'IsUsed' );
    EndIf;
    If( CellIsUpdateable( cCubSrc3, sInst, 'Admin', 'ADMIN', 'Assignment' ) = 1 );
        CellPutN( 0, cCubSrc3, sInst, 'Admin', 'ADMIN', 'Assignment' );
    EndIf;
    nInst = nInst + 1;
End;

### Loop Instances, then Clients/Groups
nMaxI   = DimSiz( cDimInstance );
nMaxC   = DimSiz( cDimSrc1 | ':Leaves' );
nMaxG   = DimSiz( cDimSrc2 | ':Leaves' );
nCtrI   = 1;
While( nCtrI <= nMaxI );
    sInstance = DimNm( cDimInstance, nCtrI );
    If( DType( cDimInstance, sInstance ) @= 'N' & sInstance @<> 'ContentStore' );
        # Loop Clients
        nCtrC = 1;
        While( nCtrC <= nMaxC );
            sClient = DimNm( cDimSrc1 | ':Leaves', nCtrC );
            If( DimIx( cDimSrc1, sClient ) = 0 );
                # the scenario of element exists in leaves but not in same named hierarchy *should* be impossible yet observed multiple times. This will sync the hierarchies.
                DimensionElementInsertDirect( cDimSrc1, '', sClient, 'N' );
                DimensionElementComponentAddDirect( cDimSrc1, 'Total Clients', sClient, 1 );
            EndIf;
            If( CellGetN( cCubSrc1, sInstance, sClient, 'ContentStoreImport' ) = 1 );
                nMetaDataRecordCount = nMetaDataRecordCount + 1;
                If( DimIx( cDimTgt1, sClient ) = 0 & sClient @<> cUsrDummy );
                    # Import user to }Clients
                    AddClient( sClient );
                EndIf;
            EndIf;
            nCtrC = nCtrC + 1;
        End;
        # Loop Groups
        nCtrG = 1;
        While( nCtrG <= nMaxG );
            sGroup = DimNm( cDimSrc2 | ':Leaves', nCtrG );
            If( DimIx( cDimSrc2, sGroup ) = 0 );
                # the scenario of element exists in leaves but not in same named hierarchy *should* be impossible yet observed multiple times. This will sync the hierarchies.
                DimensionElementInsertDirect( cDimSrc2, '', sGroup, 'N' );
                DimensionElementComponentAddDirect( cDimSrc2, 'Total Groups', sGroup, 1 );
            EndIf;
            If( CellGetN( cCubSrc2, sInstance, sGroup, 'ContentStoreImport' ) = 1 );
                nMetaDataRecordCount = nMetaDataRecordCount + 1;
                If( DimIx( cDimTgt2, sGroup ) = 0 & sGroup @<> cGrpDummy );
                    # Import group to }Groups
                    AddGroup( sGroup );
                EndIf;
            EndIf;
            nCtrG = nCtrG + 1;
        End;
    EndIf;
    nCtrI = nCtrI + 1;
End;

#EndRegion - Update Security
##############################################################################################################################

##############################################################################################################################
### END Prolog
##############################################################################################################################
573,4

#****Begin: Generated Statements***
#****End: Generated Statements****

574,4

#****Begin: Generated Statements***
#****End: Generated Statements****

575,166
##############################################################################################################################
#Region - Header
# APLIQO UX FRAMEWORK
# Copyright 2016, Apliqo AG. All rights reserved.
# This software and related documentation are provided under a license agreement containing restrictions on use and disclosure
# and are protected by intellectual property laws. Except as expressly permitted in your license agreement or allowed by law,
# you may not use, copy, reproduce, translate, broadcast, modify, license, transmit, distribute, exhibit, perform, publish,
# or display any part, in any form, or by any means.
#EndRegion - Header
##############################################################################################################################

#****Begin: Generated Statements***
#****End: Generated Statements****

##############################################################################################################################
### Epilog script
##############################################################################################################################

##############################################################################################################################
#Region - Add attributes and group memberships

### Loop source cubes to make data change (to force dependency model to recalculate rule calc numeric values after process runs)
nInst = 1;
While( nInst <= ElCompN( cDimInstance, 'Total Instances' ) );
    sInst = ElComp( cDimInstance, 'Total Instances', nInst );
    If( CellIsUpdateable( cCubSrc1, sInst, 'Admin', 'IsUsed' ) = 1 );
        CellPutN( 1, cCubSrc1, sInst, 'Admin', 'IsUsed' );
    EndIf;
    If( CellIsUpdateable( cCubSrc2, sInst, 'ADMIN', 'IsUsed' ) = 1 );
        CellPutN( 1, cCubSrc2, sInst, 'ADMIN', 'IsUsed' );
    EndIf;
    If( CellIsUpdateable( cCubSrc3, sInst, 'Admin', 'ADMIN', 'Assignment' ) = 1 );
        CellPutN( 1, cCubSrc3, sInst, 'Admin', 'ADMIN', 'Assignment' );
    EndIf;
    nInst = nInst + 1;
End;

# Clients : import alias and encrypted pwd
nCtrC = 1;
While( nCtrC <= nMaxC );
    sClient = DimNm( cDimSrc1 | ':Leaves', nCtrC );
    sAlias  = AttrS( cDimSrc1, sClient, cAlias );
    If( sAlias @<> '' & DimIx( cDimTgt1, sClient ) > 0 );
        nDataRecordCount = nDataRecordCount + 1;
        # update in }Clients dimension
        AttrPutS( sAlias, cDimTgt1, sClient, cAlias, 1 );
    EndIf;
    If( DimIx( cDimTgt1, sClient ) > 0 );
        nCtrI = 1;
        While( nCtrI <= nMaxI );
            sInstance = DimNm( cDimInstance, nCtrI );
            If( CellGetN( cCubSrc1, sInstance, sClient, 'ContentStoreImport' ) = 1 & DType( cDimInstance, sInstance ) @= 'N' & sInstance @<> 'ContentStore' );
                sPwd    = CellGetS( cCubSrc1, sInstance, sClient, sMeasPwdSrc );
                sOldPwd = CellGetS( cCubTgt4, sClient, sMeasPwdTgt );
                If( sPwd @<> sOldPwd & sPwd @<> '' & CellIsUpdateable( cCubTgt4, sClient, sMeasPwdTgt ) = 1 );
                    CellPutS( sPwd, cCubTgt4, sClient, sMeasPwdTgt );
                    CellPutS( TimSt( Now(), '\Y\m\d\h\i\s' ), cCubTgt4, sClient, 'PasswordLastTimeUpdated' );
                EndIf;
            EndIf;
            nCtrI = nCtrI + 1;
        End;
    EndIf;
    nCtrC = nCtrC + 1;
End;

# Groups : import alias
nCtrG = 1;
While( nCtrG <= nMaxG );
    sGroup = DimNm( cDimSrc2 | ':Leaves', nCtrG );
    sAlias  = AttrS( cDimSrc2, sGroup, cAlias );
    If( sAlias @<> '' & DimIx( cDimTgt2, sGroup ) > 0 );
        nDataRecordCount = nDataRecordCount + 1;
        # update in }Groups dimension
        AttrPutS( sAlias, cDimTgt2, sGroup, cAlias, 1 );
    EndIf;
    nCtrG = nCtrG + 1;
End;

# Group Memberships (loop by instance, then groups marked to import, then clients)
nCtrI   = 1;
While( nCtrI <= nMaxI );
    sInstance = DimNm( cDimInstance, nCtrI );
    If( DType( cDimInstance, sInstance ) @= 'N' & sInstance @<> 'ContentStore' );
        # Loop Groups
        nCtrG = 1;
        While( nCtrG <= nMaxG );
            sGroup = DimNm( cDimSrc2 | ':Leaves', nCtrG );
            If( CellGetN( cCubSrc2, sInstance, sGroup, 'ContentStoreImport' ) = 1 & DimIx( cDimTgt2, sGroup ) > 0 );
                # Group marked to import, now check which clients are members
                nCtrC = 1;
                While( nCtrC <= nMaxC );
                    sClient = DimNm( cDimSrc1 | ':Leaves', nCtrC );
                    If( CellGetN( cCubSrc3, sInstance, sClient, sGroup, 'Assignment' ) = 1 & DimIx( cDimTgt1, sClient ) > 0 );
                        nDataRecordCount = nDataRecordCount + 1;
                        # Import group membership
                        If( CellIsUpdateable( cCubTgt2, sClient, sGroup, 'Assignment' ) = 1 );
                            CellPutN( 1, cCubTgt2, sClient, sGroup, 'Assignment' );
                        EndIf;
                        AssignClientToGroup( sClient, sGroup );
                    EndIf;
                    nCtrC = nCtrC + 1;
                End;
            EndIf;
            nCtrG = nCtrG + 1;
        End;
    EndIf;
    nCtrI = nCtrI + 1;
    #1663, BB#243 - Ensure Admin always in ADMIN group 
    AssignClientToGroup( 'Admin', 'ADMIN' );
    CellPutS( 'ADMIN', cCubTgt1, 'Admin', 'ADMIN' );
End;

# All users in contentStore must be members of "APQ User" group
nMaxC   = DimSiz( cDimTgt1 );
nCtrC   = 1;
While( nCtrC <= nMaxC );
    sClient = DimNm( cDimTgt1, nCtrC );
    If( sClient @<> 'Admin' );
        AssignClientToGroup( sClient, 'APQ User' );
        If( CellIsUpdateable( cCubTgt2, sClient, 'APQ User', 'Assignment' ) = 1 );
            CellPutN( 1, cCubTgt2, sClient, 'APQ User', 'Assignment' );
        EndIf;
    EndIf;
    nCtrC = nCtrC + 1;
End;

# Ensure dimension security is set for alternate hierarchies
nMaxD   = DimSiz( '}Dimensions' );
nCtrD   = 1;
While( nCtrD <= nMaxD );
    sDim = DimNm( '}Dimensions', nCtrD );
    If( SubSt( sDim, 1, 14 ) @= cDimSrc1 % SubSt( sDim, 1, 13 ) @= cDimSrc2 );
        # Only APQ Admin group should have access to clients & groups by instance
        CellPutS( 'READ', cCubTgt3, sDim, cGrpAdmn );
    ElseIf( SubSt( sDim, 1, 12 ) @= '}APQ UX Cube' );
        # APQ PUser & APQ Admin group should have access to cubes by instance
        CellPutS( 'READ', cCubTgt3, sDim, cGrpAdmn );
        CellPutS( 'READ', cCubTgt3, sDim, cGrpPUsr );
    ElseIf( SubSt( sDim, 1, 17 ) @= '}APQ UX Dimension' );
        # APQ User group should have access to dimensions by instance (for settings service preferences). As all users are in APQ User no need to add for other APQ groups
        CellPutS( 'READ', cCubTgt3, sDim, cGrpUsr );
    EndIf;
    nCtrD = nCtrD + 1;
End;

# Refresh security
SecurityRefresh;

#EndRegion - Add attributes and group memberships
##############################################################################################################################

##############################################################################################################################
#Region - Logging
IF( pDoProcessLogging @= '1' );
  nProcessFinishTime = Now(); sProcessErrorLogFile = GetProcessErrorFileName; sYear01 = sLogYear; sYear02 = sLogYear; sDay01 = sLogDay; sDay02 = 'D000'; sMinute01 = sLogMinute; sMinute02 = 'Total Day Entry'; sSecond01 = sLogSecond; sSecond02= 'Last Entry'; nCountTime = 1; nTotalLogTime = 2; 
  While( nCountTime <= nTotalLogTime );    sLoggingYear = Expand( '%sYear' | NumberToStringEx( nCountTime, '00', '', '' ) | '%' ); sLoggingDay = Expand( '%sDay' | NumberToStringEx( nCountTime, '00', '', '' ) | '%' ); sLoggingMinute = Expand( '%sMinute' | NumberToStringEx( nCountTime, '00', '', '' ) | '%' ); sLoggingSecond = Expand( '%sSecond' | NumberToStringEx( nCountTime, '00', '', '' ) | '%' );
  CellPutN( nProcessFinishTime, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nProcessFinishTime' ); CellPutN( 1, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nProcessCompletedFlag' );
  CellPutN( nMetaDataRecordCount, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nMetaDataRecordCount' ); CellPutN( nDataRecordCount, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nDataRecordCount' );
  CellPutN( PrologMinorErrorCount, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nPrologMinorErrorCount' ); CellPutN( MetadataMinorErrorCount, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nMetaDataMinorErrorCount' );
  CellPutN( DataMinorErrorCount, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nDataMinorErrorCount' ); CellPutN( ProcessReturnCode, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'nProcessReturnCode' );
  CellPutS( sProcessErrorLogFile, sProcLogCube, sLoggingYear, sLoggingDay, sLoggingMinute, sLoggingSecond, sThisProcName, 'sProcessErrorLogFile' );  nCountTime = nCountTime + 1; End;
EndIF;
#EndRegion - Logging
##############################################################################################################################
### END Epilog
##############################################################################################################################
576,
930,0
638,1
804,0
1217,1
900,
901,
902,
938,0
937,
936,
935,
934,
932,0
933,0
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
